<!-- This comment will put IE 6, 7 and 8 in quirks mode -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>TIOVX Tutorials: vx_tutorial_image_extract_channel.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javaScript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<img src="ti_logo.gif">
<tr bgcolor="#CCCCCC"> 
      <td bgcolor="#FFFFFF">
        <hr align="left" noshade size="1">
      </td>
</tr>
<!-- Generated by Doxygen 1.6.1 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="main.html"><span>Main&nbsp;Page</span></a></li>
    </ul>
  </div>
<h1>vx_tutorial_image_extract_channel.c</h1><a href="vx__tutorial__image__extract__channel_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">*</span>
<a name="l00003"></a>00003 <span class="comment">* Copyright (c) 2017 Texas Instruments Incorporated</span>
<a name="l00004"></a>00004 <span class="comment">*</span>
<a name="l00005"></a>00005 <span class="comment">* All rights reserved not granted herein.</span>
<a name="l00006"></a>00006 <span class="comment">*</span>
<a name="l00007"></a>00007 <span class="comment">* Limited License.</span>
<a name="l00008"></a>00008 <span class="comment">*</span>
<a name="l00009"></a>00009 <span class="comment">* Texas Instruments Incorporated grants a world-wide, royalty-free, non-exclusive</span>
<a name="l00010"></a>00010 <span class="comment">* license under copyrights and patents it now or hereafter owns or controls to make,</span>
<a name="l00011"></a>00011 <span class="comment">* have made, use, import, offer to sell and sell (&quot;Utilize&quot;) this software subject to the</span>
<a name="l00012"></a>00012 <span class="comment">* terms herein.  With respect to the foregoing patent license, such license is granted</span>
<a name="l00013"></a>00013 <span class="comment">* solely to the extent that any such patent is necessary to Utilize the software alone.</span>
<a name="l00014"></a>00014 <span class="comment">* The patent license shall not apply to any combinations which include this software,</span>
<a name="l00015"></a>00015 <span class="comment">* other than combinations with devices manufactured by or for TI (&quot;TI Devices&quot;).</span>
<a name="l00016"></a>00016 <span class="comment">* No hardware patent is licensed hereunder.</span>
<a name="l00017"></a>00017 <span class="comment">*</span>
<a name="l00018"></a>00018 <span class="comment">* Redistributions must preserve existing copyright notices and reproduce this license</span>
<a name="l00019"></a>00019 <span class="comment">* (including the above copyright notice and the disclaimer and (if applicable) source</span>
<a name="l00020"></a>00020 <span class="comment">* code license limitations below) in the documentation and/or other materials provided</span>
<a name="l00021"></a>00021 <span class="comment">* with the distribution</span>
<a name="l00022"></a>00022 <span class="comment">*</span>
<a name="l00023"></a>00023 <span class="comment">* Redistribution and use in binary form, without modification, are permitted provided</span>
<a name="l00024"></a>00024 <span class="comment">* that the following conditions are met:</span>
<a name="l00025"></a>00025 <span class="comment">*</span>
<a name="l00026"></a>00026 <span class="comment">* *       No reverse engineering, decompilation, or disassembly of this software is</span>
<a name="l00027"></a>00027 <span class="comment">* permitted with respect to any software provided in binary form.</span>
<a name="l00028"></a>00028 <span class="comment">*</span>
<a name="l00029"></a>00029 <span class="comment">* *       any redistribution and use are licensed by TI for use only with TI Devices.</span>
<a name="l00030"></a>00030 <span class="comment">*</span>
<a name="l00031"></a>00031 <span class="comment">* *       Nothing shall obligate TI to provide you with source code for the software</span>
<a name="l00032"></a>00032 <span class="comment">* licensed and provided to you in object code.</span>
<a name="l00033"></a>00033 <span class="comment">*</span>
<a name="l00034"></a>00034 <span class="comment">* If software source code is provided to you, modification and redistribution of the</span>
<a name="l00035"></a>00035 <span class="comment">* source code are permitted provided that the following conditions are met:</span>
<a name="l00036"></a>00036 <span class="comment">*</span>
<a name="l00037"></a>00037 <span class="comment">* *       any redistribution and use of the source code, including any resulting derivative</span>
<a name="l00038"></a>00038 <span class="comment">* works, are licensed by TI for use only with TI Devices.</span>
<a name="l00039"></a>00039 <span class="comment">*</span>
<a name="l00040"></a>00040 <span class="comment">* *       any redistribution and use of any object code compiled from the source code</span>
<a name="l00041"></a>00041 <span class="comment">* and any resulting derivative works, are licensed by TI for use only with TI Devices.</span>
<a name="l00042"></a>00042 <span class="comment">*</span>
<a name="l00043"></a>00043 <span class="comment">* Neither the name of Texas Instruments Incorporated nor the names of its suppliers</span>
<a name="l00044"></a>00044 <span class="comment">*</span>
<a name="l00045"></a>00045 <span class="comment">* may be used to endorse or promote products derived from this software without</span>
<a name="l00046"></a>00046 <span class="comment">* specific prior written permission.</span>
<a name="l00047"></a>00047 <span class="comment">*</span>
<a name="l00048"></a>00048 <span class="comment">* DISCLAIMER.</span>
<a name="l00049"></a>00049 <span class="comment">*</span>
<a name="l00050"></a>00050 <span class="comment">* THIS SOFTWARE IS PROVIDED BY TI AND TI&apos;S LICENSORS &quot;AS IS&quot; AND ANY EXPRESS</span>
<a name="l00051"></a>00051 <span class="comment">* OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES</span>
<a name="l00052"></a>00052 <span class="comment">* OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.</span>
<a name="l00053"></a>00053 <span class="comment">* IN NO EVENT SHALL TI AND TI&apos;S LICENSORS BE LIABLE FOR ANY DIRECT, INDIRECT,</span>
<a name="l00054"></a>00054 <span class="comment">* INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,</span>
<a name="l00055"></a>00055 <span class="comment">* BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,</span>
<a name="l00056"></a>00056 <span class="comment">* DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY</span>
<a name="l00057"></a>00057 <span class="comment">* OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE</span>
<a name="l00058"></a>00058 <span class="comment">* OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED</span>
<a name="l00059"></a>00059 <span class="comment">* OF THE POSSIBILITY OF SUCH DAMAGE.</span>
<a name="l00060"></a>00060 <span class="comment">*</span>
<a name="l00061"></a>00061 <span class="comment">*/</span>
<a name="l00062"></a>00062 
<a name="l00063"></a>00063 
<a name="l00064"></a>00064 
<a name="l00094"></a>00094 <span class="preprocessor">#include &lt;stdio.h&gt;</span>
<a name="l00095"></a>00095 <span class="preprocessor">#include &lt;VX/vx.h&gt;</span>
<a name="l00096"></a>00096 <span class="preprocessor">#include &lt;VX/vxu.h&gt;</span>
<a name="l00097"></a>00097 <span class="preprocessor">#include &lt;<a class="code" href="utility_8h.html">utility.h</a>&gt;</span>
<a name="l00098"></a>00098 
<a name="l00100"></a><a class="code" href="vx__tutorial__image__extract__channel_8c.html#a8118656bb5a60090a1dbffa402168438">00100</a> <span class="preprocessor">#define IN_FILE_NAME       &quot;colors.bmp&quot;</span>
<a name="l00101"></a>00101 <span class="preprocessor"></span>
<a name="l00103"></a><a class="code" href="vx__tutorial__image__extract__channel_8c.html#a75506823f0db0ef3f4f022cf132dbbbb">00103</a> <span class="preprocessor">#define OUT_FILE_NAME      &quot;vx_tutorial_image_extract_channel_out.bmp&quot;</span>
<a name="l00104"></a>00104 <span class="preprocessor"></span>
<a name="l00108"></a><a class="code" href="vx__tutorial__image__extract__channel_8c.html#a60cb60cf502b64d0cc7332e95ff625bd">00108</a> <span class="keywordtype">void</span> <a class="code" href="vx__tutorial__image__extract__channel_8c.html#a60cb60cf502b64d0cc7332e95ff625bd" title="Tutorial Entry Point.">vx_tutorial_image_extract_channel</a>()
<a name="l00109"></a>00109 {
<a name="l00117"></a>00117     vx_context context;
<a name="l00118"></a>00118     vx_image in_image = NULL;
<a name="l00119"></a>00119     vx_image r_channel = NULL;
<a name="l00120"></a>00120     vx_image g_channel = NULL;
<a name="l00121"></a>00121     vx_image b_channel = NULL;
<a name="l00122"></a>00122     vx_image out_image = NULL;
<a name="l00124"></a>00124     vx_uint32 width, height;
<a name="l00125"></a>00125 
<a name="l00126"></a>00126     printf(<span class="stringliteral">&quot; vx_tutorial_image_extract_channel: Tutorial Started !!! \n&quot;</span>);
<a name="l00127"></a>00127 
<a name="l00135"></a>00135     context = vxCreateContext();
<a name="l00138"></a>00138     printf(<span class="stringliteral">&quot; Loading file %s ...\n&quot;</span>, <a class="code" href="vx__tutorial__image__load__save_8c.html#a8118656bb5a60090a1dbffa402168438" title="Input file name.">IN_FILE_NAME</a>);
<a name="l00139"></a>00139 
<a name="l00147"></a>00147     in_image = <a class="code" href="utility_8h.html#af8e9cbbd49ab0dec7850267224548cd6" title="Create a image data object given BMP filename as input.">create_image_from_file</a>(context, <a class="code" href="vx__tutorial__image__load__save_8c.html#a8118656bb5a60090a1dbffa402168438" title="Input file name.">IN_FILE_NAME</a>, vx_false_e);
<a name="l00150"></a>00150     vxSetReferenceName((vx_reference)in_image, <span class="stringliteral">&quot;INPUT&quot;</span>);
<a name="l00158"></a>00158     <a class="code" href="utility_8h.html#ade45042efce712b30cf8254a6c90b3bc" title="Show attributes of previously created image.">show_image_attributes</a>(in_image);
<a name="l00161"></a>00161     vxQueryImage(in_image, VX_IMAGE_WIDTH, &amp;width, <span class="keyword">sizeof</span>(vx_uint32));
<a name="l00162"></a>00162     vxQueryImage(in_image, VX_IMAGE_HEIGHT, &amp;height, <span class="keyword">sizeof</span>(vx_uint32));
<a name="l00163"></a>00163 
<a name="l00171"></a>00171     r_channel = vxCreateImage(context, width, height, VX_DF_IMAGE_U8);
<a name="l00174"></a>00174     vxSetReferenceName((vx_reference)r_channel, <span class="stringliteral">&quot;R_CHANNEL&quot;</span>);
<a name="l00175"></a>00175 
<a name="l00183"></a>00183     <a class="code" href="utility_8h.html#ade45042efce712b30cf8254a6c90b3bc" title="Show attributes of previously created image.">show_image_attributes</a>(r_channel);
<a name="l00193"></a>00193     g_channel = vxCreateImage(context, width, height, VX_DF_IMAGE_U8);
<a name="l00196"></a>00196     vxSetReferenceName((vx_reference)g_channel, <span class="stringliteral">&quot;G_CHANNEL&quot;</span>);
<a name="l00197"></a>00197     <a class="code" href="utility_8h.html#ade45042efce712b30cf8254a6c90b3bc" title="Show attributes of previously created image.">show_image_attributes</a>(g_channel);
<a name="l00198"></a>00198 
<a name="l00206"></a>00206     b_channel = vxCreateImage(context, width, height, VX_DF_IMAGE_U8);
<a name="l00209"></a>00209     vxSetReferenceName((vx_reference)b_channel, <span class="stringliteral">&quot;B_CHANNEL&quot;</span>);
<a name="l00210"></a>00210 
<a name="l00218"></a>00218     <a class="code" href="utility_8h.html#ade45042efce712b30cf8254a6c90b3bc" title="Show attributes of previously created image.">show_image_attributes</a>(b_channel);
<a name="l00228"></a>00228     out_image = vxCreateImage(context, width, height, VX_DF_IMAGE_RGB);
<a name="l00231"></a>00231     vxSetReferenceName((vx_reference)out_image, <span class="stringliteral">&quot;OUTPUT&quot;</span>);
<a name="l00232"></a>00232 
<a name="l00240"></a>00240     <a class="code" href="utility_8h.html#ade45042efce712b30cf8254a6c90b3bc" title="Show attributes of previously created image.">show_image_attributes</a>(out_image);
<a name="l00251"></a>00251     vxuChannelExtract(context, in_image, VX_CHANNEL_R, r_channel);
<a name="l00252"></a>00252     vxuChannelExtract(context, in_image, VX_CHANNEL_G, g_channel);
<a name="l00253"></a>00253     vxuChannelExtract(context, in_image, VX_CHANNEL_B, b_channel);
<a name="l00263"></a>00263     vxuChannelCombine(context, b_channel, g_channel, r_channel, NULL, out_image);
<a name="l00266"></a>00266     printf(<span class="stringliteral">&quot; Saving to file %s ...\n&quot;</span>, <a class="code" href="vx__tutorial__image__load__save_8c.html#a75506823f0db0ef3f4f022cf132dbbbb" title="Output file name.">OUT_FILE_NAME</a>);
<a name="l00267"></a>00267 
<a name="l00276"></a>00276     <a class="code" href="utility_8h.html#a2ffb77a8e510c0236b07306d0eb47a30" title="Save data from image object to BMP file.">save_image_to_file</a>(<a class="code" href="vx__tutorial__image__load__save_8c.html#a75506823f0db0ef3f4f022cf132dbbbb" title="Output file name.">OUT_FILE_NAME</a>, out_image);
<a name="l00285"></a>00285     vxReleaseImage(&amp;in_image);
<a name="l00286"></a>00286     vxReleaseImage(&amp;r_channel);
<a name="l00287"></a>00287     vxReleaseImage(&amp;g_channel);
<a name="l00288"></a>00288     vxReleaseImage(&amp;b_channel);
<a name="l00289"></a>00289     vxReleaseImage(&amp;out_image);
<a name="l00300"></a>00300     vxReleaseContext(&amp;context);
<a name="l00303"></a>00303     printf(<span class="stringliteral">&quot; vx_tutorial_image_extract_channel: Tutorial Done !!! \n&quot;</span>);
<a name="l00304"></a>00304     printf(<span class="stringliteral">&quot; \n&quot;</span>);
<a name="l00305"></a>00305 }
</pre></div></div>

<html>
<table bordercolor="#FFFFFF" bgcolor="#FFFFFF" width="100%">
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF">
        <hr align="left" noshade size="1">
      </td>
</tr>
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" color="#000000"><b><i>
        &copy Copyright 2017 Texas Instruments Incorporated. All rights reserved. </i></b></font></td>
</tr>
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" color="#000000">
        Document generated by <b><i> doxygen </i></b> 1.6.1
  </font></td>
</tr>
</table>
